'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var cn = require('classnames');
var coreComponentsIconButton = require('@alfalab/core-components-icon-button');
var coreComponentsLink = require('@alfalab/core-components-link');
var coreComponentsSpinner = require('@alfalab/core-components-spinner');
var AlertCircleMIcon = require('@alfalab/icons-glyph/AlertCircleMIcon');
var CheckmarkCircleMIcon = require('@alfalab/icons-glyph/CheckmarkCircleMIcon');
var ClockMIcon = require('@alfalab/icons-glyph/ClockMIcon');
var CrossSIcon = require('@alfalab/icons-glyph/CrossSIcon');
var PointerDownSIcon = require('@alfalab/icons-glyph/PointerDownSIcon');
var utils = require('./utils.js');

function _interopDefaultCompat (e) { return e && typeof e === 'object' && 'default' in e ? e : { default: e }; }

var React__default = /*#__PURE__*/_interopDefaultCompat(React);
var cn__default = /*#__PURE__*/_interopDefaultCompat(cn);

var styles = {"component":"file-upload-item__component_8sw4y","infoSection":"file-upload-item__infoSection_8sw4y","info":"file-upload-item__info_8sw4y","icon":"file-upload-item__icon_8sw4y","errorIcon":"file-upload-item__errorIcon_8sw4y","successIcon":"file-upload-item__successIcon_8sw4y","name":"file-upload-item__name_8sw4y","rowLimit":"file-upload-item__rowLimit_8sw4y","meta":"file-upload-item__meta_8sw4y","size":"file-upload-item__size_8sw4y","delete":"file-upload-item__delete_8sw4y","download":"file-upload-item__download_8sw4y","errorWrapper":"file-upload-item__errorWrapper_8sw4y","restore":"file-upload-item__restore_8sw4y","spinnerWrapper":"file-upload-item__spinnerWrapper_8sw4y","spinner":"file-upload-item__spinner_8sw4y","uploadPercent":"file-upload-item__uploadPercent_8sw4y"};
require('./index.css')

var FileUploadItem = function (_a) {
    var className = _a.className, children = _a.children, _b = _a.id, id = _b === void 0 ? '0' : _b, _c = _a.name, name = _c === void 0 ? '' : _c, size = _a.size, _d = _a.icon, Icon = _d === void 0 ? utils.fileIcon(name) : _d, uploadDate = _a.uploadDate, downloadLink = _a.downloadLink, download = _a.download, uploadStatus = _a.uploadStatus, _e = _a.uploadPercent, uploadPercent = _e === void 0 ? 0 : _e, error = _a.error, showDelete = _a.showDelete, showRestore = _a.showRestore, onDelete = _a.onDelete, onDownload = _a.onDownload, onRestore = _a.onRestore, disableButtons = _a.disableButtons, _f = _a.multiline, multiline = _f === void 0 ? false : _f, target = _a.target, dataTestId = _a.dataTestId;
    var handleDownload = function (event) {
        if (onDownload) {
            event.preventDefault();
            onDownload(id);
        }
    };
    var handleDelete = function (event) {
        if (onDelete)
            onDelete(id, event);
    };
    var handleRestore = function () {
        if (onRestore)
            onRestore(id);
    };
    var renderIcon = function () {
        if (showRestore) {
            return React__default.default.createElement(ClockMIcon.ClockMIcon, { className: styles.restoreIcon });
        }
        switch (uploadStatus) {
            case 'ERROR':
                return React__default.default.createElement(AlertCircleMIcon.AlertCircleMIcon, { className: styles.errorIcon });
            case 'SUCCESS':
                return React__default.default.createElement(CheckmarkCircleMIcon.CheckmarkCircleMIcon, { className: styles.successIcon });
            case 'LOADING':
            case 'UPLOADING':
                return (React__default.default.createElement("div", { className: styles.spinnerWrapper },
                    React__default.default.createElement(coreComponentsSpinner.Spinner, { visible: true, className: styles.spinner })));
            default: {
                return React__default.default.createElement(Icon, { className: styles.icon });
            }
        }
    };
    var renderInfoSection = function () {
        var _a;
        var shouldShownError = uploadStatus === 'ERROR' || !!error;
        var errorContent = uploadStatus === 'ERROR' && !error ? 'Не удалось загрузить файл' : error;
        return (React__default.default.createElement("div", { className: styles.infoSection },
            React__default.default.createElement("div", { className: cn__default.default(styles.name, (_a = {}, _a[styles.rowLimit] = !multiline, _a)) }, name),
            shouldShownError && (React__default.default.createElement("div", { className: styles.errorWrapper, role: 'alert' }, errorContent))));
    };
    var showMeta = !showRestore && (!uploadStatus || uploadStatus === 'SUCCESS');
    var showDownload = Boolean(downloadLink) && !showRestore;
    return (React__default.default.createElement("div", { className: cn__default.default(className, styles.component, uploadStatus && styles[uploadStatus.toLocaleLowerCase()]), "data-test-id": dataTestId },
        React__default.default.createElement("div", { className: styles.info },
            renderIcon(),
            renderInfoSection(),
            children,
            uploadStatus === 'UPLOADING' && (React__default.default.createElement("span", { className: styles.uploadPercent }, "".concat(Math.round(uploadPercent), "%"))),
            showMeta && (React__default.default.createElement("div", { className: styles.meta },
                uploadDate && React__default.default.createElement("span", { key: uploadDate }, uploadDate),
                size && (React__default.default.createElement("span", { key: size, className: styles.size }, utils.humanFileSize(size)))))),
        showRestore && (React__default.default.createElement(coreComponentsLink.Link, { pseudo: true, className: styles.restore, onClick: handleRestore }, "\u0412\u043E\u0441\u0441\u0442\u0430\u043D\u043E\u0432\u0438\u0442\u044C")),
        showDownload && (React__default.default.createElement(coreComponentsIconButton.IconButton, { size: 'xxs', icon: PointerDownSIcon.PointerDownSIcon, className: styles.download, "aria-label": '\u0441\u043A\u0430\u0447\u0430\u0442\u044C', href: downloadLink, onClick: handleDownload, disabled: disableButtons, download: download, target: target })),
        showDelete && !showRestore && (React__default.default.createElement(coreComponentsIconButton.IconButton, { size: 'xxs', icon: CrossSIcon.CrossSIcon, onClick: handleDelete, disabled: disableButtons, className: styles.delete, "aria-label": '\u0443\u0434\u0430\u043B\u0438\u0442\u044C' }))));
};

exports.FileUploadItem = FileUploadItem;
